/**
 * 
 */
package org.foo.bar.mongo.service.impl;

import org.foo.bar.mongo.domain.User;
import org.foo.bar.mongo.repository.UserRepository;
import org.foo.bar.mongo.service.UserService;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;

/**
 * @author ctranxuan
 * 
 */
public class UserServiceImpl implements UserService {
    private UserRepository userRepository;

    /**
     * @param aEntity
     * @return
     * @see org.springframework.data.repository.CrudRepository#save(java.lang.Object)
     */
    @Override
    public <S extends User> S save(final S aEntity) {
        return userRepository.save(aEntity);
    }

    /**
     * @param aSort
     * @return
     * @see org.springframework.data.repository.PagingAndSortingRepository#findAll(org.springframework.data.domain.Sort)
     */
    @Override
    public Iterable<User> findAll(final Sort aSort) {
        return userRepository.findAll(aSort);
    }

    /**
     * @param aEntities
     * @return
     * @see org.springframework.data.repository.CrudRepository#save(java.lang.Iterable)
     */
    @Override
    public <S extends User> Iterable<S> save(final Iterable<S> aEntities) {
        return userRepository.save(aEntities);
    }

    /**
     * @param aPageable
     * @return
     * @see org.springframework.data.repository.PagingAndSortingRepository#findAll(org.springframework.data.domain.Pageable)
     */
    @Override
    public Page<User> findAll(final Pageable aPageable) {
        return userRepository.findAll(aPageable);
    }

    /**
     * @param aId
     * @return
     * @see org.springframework.data.repository.CrudRepository#findOne(java.io.Serializable)
     */
    @Override
    public User findOne(final String aId) {
        return userRepository.findOne(aId);
    }

    /**
     * @param aId
     * @return
     * @see org.springframework.data.repository.CrudRepository#exists(java.io.Serializable)
     */
    @Override
    public boolean exists(final String aId) {
        return userRepository.exists(aId);
    }

    /**
     * @return
     * @see org.springframework.data.repository.CrudRepository#findAll()
     */
    @Override
    public Iterable<User> findAll() {
        return userRepository.findAll();
    }

    /**
     * @param aIds
     * @return
     * @see org.springframework.data.repository.CrudRepository#findAll(java.lang.Iterable)
     */
    @Override
    public Iterable<User> findAll(final Iterable<String> aIds) {
        return userRepository.findAll(aIds);
    }

    /**
     * @return
     * @see org.springframework.data.repository.CrudRepository#count()
     */
    @Override
    public long count() {
        return userRepository.count();
    }

    /**
     * @param aId
     * @see org.springframework.data.repository.CrudRepository#delete(java.io.Serializable)
     */
    @Override
    public void delete(final String aId) {
        userRepository.delete(aId);
    }

    /**
     * @param aEntity
     * @see org.springframework.data.repository.CrudRepository#delete(java.lang.Object)
     */
    @Override
    public void delete(final User aEntity) {
        userRepository.delete(aEntity);
    }

    /**
     * @param aEntities
     * @see org.springframework.data.repository.CrudRepository#delete(java.lang.Iterable)
     */
    @Override
    public void delete(final Iterable<? extends User> aEntities) {
        userRepository.delete(aEntities);
    }

    /**
     * 
     * @see org.springframework.data.repository.CrudRepository#deleteAll()
     */
    @Override
    public void deleteAll() {
        userRepository.deleteAll();
    }

    /**
     * @return the userRepository
     */
    @Override
    public UserRepository getUserRepository() {
        return userRepository;
    }

    /**
     * @param aUserRepository
     *            the userRepository to set
     */
    @Override
    public void setUserRepository(final UserRepository aUserRepository) {
        userRepository = aUserRepository;
    }
}
